using System;
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

namespace SpiceLogic.PayPalProSOAP.Core
{
    public class CreateRecurringPaymentsProfile
    {
        public string CreateRecurringPaymentsProfileCode(string token, DateTime date, string amount, int BF, BillingPeriodType BP, CurrencyCodeType currencyCodeType)
        {
            CallerServices caller = new CallerServices();

            IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
            /*
             WARNING: Do not embed plaintext credentials in your application code.
             Doing so is insecure and against best practices.
             Your API credentials must be handled securely. Please consider
             encrypting them for use in any production environment, and ensure
             that only authorized individuals may view or modify them.
             */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            // Create the request object.
            CreateRecurringPaymentsProfileRequestType pp_request = new CreateRecurringPaymentsProfileRequestType
            {
                Version = ConfigData.APIVersion,
                CreateRecurringPaymentsProfileRequestDetails =
                    new CreateRecurringPaymentsProfileRequestDetailsType
                    {
                        Token
                            =
                            token,
                        RecurringPaymentsProfileDetails
                            =
                            new RecurringPaymentsProfileDetailsType
                            {
                                BillingStartDate
                                    =
                                    date
                            }
                    }
            };

            // Add request-specific fields to the request.
            pp_request.CreateRecurringPaymentsProfileRequestDetails.ScheduleDetails = new ScheduleDetailsType
            {
                PaymentPeriod =
                    new BillingPeriodDetailsType
                    {
                        Amount
                            =
                            new BasicAmountType
                            {
                                Value
                                    =
                                    amount,
                                currencyID
                                    =
                                    currencyCodeType
                            }
                    }
            };

            pp_request.CreateRecurringPaymentsProfileRequestDetails.ScheduleDetails.PaymentPeriod.BillingFrequency = BF;
            pp_request.CreateRecurringPaymentsProfileRequestDetails.ScheduleDetails.PaymentPeriod.BillingPeriod = BP;////Enum for BillingPeriod is  BillingPeriodType.Day

            // Execute the API operation and obtain the response.
            CreateRecurringPaymentsProfileResponseType pp_response = (CreateRecurringPaymentsProfileResponseType)caller.Call("CreateRecurringPaymentsProfile", pp_request);
            return pp_response.Ack.ToString();
        }

    }
}
