/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * DoCapture SOAP example; last modified 08MAY23. 
 *
 * Capture a payment.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class DoCapture
	{
	    public string DoCaptureCode(string authorizationId, string note, string value, CurrencyCodeType currencyId, string invoiceId)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            DoCaptureRequestType pp_request = new DoCaptureRequestType
            {
                Version = ConfigData.APIVersion,
                AuthorizationID = authorizationId,
                Note = note,
                Amount = new BasicAmountType
                {
                    Value = value,
                    currencyID = currencyId
                },
                InvoiceID = invoiceId
            };

	        // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        DoCaptureResponseType pp_response = (DoCaptureResponseType)  caller.Call("DoCapture", pp_request);
			return pp_response.Ack.ToString();
		}
	}
}
