using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

namespace SpiceLogic.PayPalProSOAP.Core
{
	public class DoVoid
	{
	    public string DoVoidCode(string authorizationId, string note)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            DoVoidRequestType pp_request = new DoVoidRequestType
            {
                Version = ConfigData.APIVersion,
                AuthorizationID = authorizationId,
                Note = note
            };

	        // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        DoVoidResponseType pp_response = (DoVoidResponseType) caller.Call("DoVoid", pp_request);
			return pp_response.Ack.ToString();

		}
	}
}
