using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

namespace SpiceLogic.PayPalProSOAP.Core
{
	public class ECDoExpressCheckout
	{
	    public string ECDoExpressCheckoutCode(string token, string payerID, string paymentAmount, PaymentActionCodeType paymentAction, CurrencyCodeType currencyCodeType)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            // Create the request object.
            DoExpressCheckoutPaymentRequestType pp_request = new DoExpressCheckoutPaymentRequestType
            {
                Version = ConfigData.APIVersion,
                DoExpressCheckoutPaymentRequestDetails =
                    new DoExpressCheckoutPaymentRequestDetailsType
                    {
                        Token = token,
                        PayerID = payerID,
                        PaymentAction = paymentAction,
                        PaymentDetails = new PaymentDetailsType
                        {
                            OrderTotal = new BasicAmountType
                            {
                                currencyID = currencyCodeType,
                                Value = paymentAmount
                            }
                        }
                    }
            };

	        // Add request-specific fields to the request.
            // Create the request details object.

	        // Execute the API operation and obtain the response.
	        DoExpressCheckoutPaymentResponseType pp_response = (DoExpressCheckoutPaymentResponseType) caller.Call("DoExpressCheckoutPayment", pp_request);
			return pp_response.Ack.ToString();
		}

	}
}
