/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * GetExpressCheckoutDetails SOAP example; last modified 08MAY23. 
 *
 * Get information about an Express Checkout transaction.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class ECGetExpressCheckout
	{
	    public string ECGetExpressCheckoutCode(string token)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

			// Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            // Create the request object.
            GetExpressCheckoutDetailsRequestType pp_request = new GetExpressCheckoutDetailsRequestType
            {
                Version = ConfigData.APIVersion,
                Token = token
            };

            // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        GetExpressCheckoutDetailsResponseType pp_response = (GetExpressCheckoutDetailsResponseType) caller.Call("GetExpressCheckoutDetails", pp_request);
			return pp_response.Ack.ToString();

		}

	}
}
