/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 */
using System;
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	/// <summary>
	/// Summary description for PayLater.
	/// </summary>
	public class PayLater
	{
	    public string PayLaterCodeEcSet(string paymentAmount, string returnURL, string cancelURL, PaymentActionCodeType paymentAction, CurrencyCodeType currencyCodeType)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

            // Create the request object
            SetExpressCheckoutRequestType pp_request = new SetExpressCheckoutRequestType
            {
                Version = ConfigData.APIVersion,
                SetExpressCheckoutRequestDetails =
                    new SetExpressCheckoutRequestDetailsType
                    {
                        PaymentAction
                            =
                            paymentAction,
                        PaymentActionSpecified
                            =
                            true,
                        OrderTotal
                            =
                            new BasicAmountType
                            {
                                currencyID
                                    =
                                    currencyCodeType,
                                Value
                                    =
                                    paymentAmount
                            }
                    }
            };

	        // Create the request details object

	        pp_request.SetExpressCheckoutRequestDetails.CancelURL = cancelURL;
			pp_request.SetExpressCheckoutRequestDetails.ReturnURL = returnURL;
			
			String[] myPromo = new String[2];
	        myPromo[0] = ConfigData.PromoCode;
			pp_request.SetExpressCheckoutRequestDetails.PromoCodes=myPromo;

	        SetExpressCheckoutResponseType pp_response = (SetExpressCheckoutResponseType) caller.Call("SetExpressCheckout", pp_request);

			return pp_response.Ack.ToString();

		}
	}
}
