/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * GetTransactionDetails SOAP example; last modified 08MAY23. 
 *
 * Get detailed information about a single transaction.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class GetTransactionDetails
	{
        public GetTransactionDetailsResponseType GetTransactionDetailsCode(string trxID)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
			profile.APIUsername = ConfigData._apiUserName;
			profile.APIPassword = ConfigData._apiPassword;
			profile.APISignature = ConfigData._apiSignature;
			profile.Environment= ConfigData.PayPalEnvironment;
			caller.APIProfile = profile;

			// Create the request object.
			GetTransactionDetailsRequestType concreteRequest = new GetTransactionDetailsRequestType
			                                                       {
			                                                           Version = ConfigData.APIVersion,
			                                                           TransactionID = trxID
			                                                       };

	        // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        GetTransactionDetailsResponseType pp_response = (GetTransactionDetailsResponseType) caller.Call("GetTransactionDetails", concreteRequest);
            return pp_response; //pp_response.Ack.ToString();

		}
	}
}
