/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * MassPay SOAP example; last modified 08MAY23. 
 *
 * Pay one or more recipients.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class MassPay
	{
	    readonly MassPayRequestType pp_request = new MassPayRequestType();

	    public string MassPayCode(string EmailSubject,ReceiverInfoCodeType receiverType,string[] ReceiverEmail, string[] value, string[] UniqueId,string[] note,CurrencyCodeType[] currencyId,int Count)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;
			
			// Create the request object.
			pp_request.MassPayItem= new MassPayRequestItemType[Count];
	        pp_request.Version = ConfigData.APIVersion;

            // Add request-specific fields to the request.

	        for (int i=0;i<Count;i++)
			{
                pp_request.MassPayItem[i] = new MassPayRequestItemType
                {
                    ReceiverEmail = ReceiverEmail[i],
                    Amount = new BasicAmountType
                    {
                        Value =
                            value
                            [i],
                        currencyID
                            =
                            currencyId
                            [i]
                    },
                    UniqueId = UniqueId[i],
                    Note = note[i]
                };
            }
			
			pp_request.EmailSubject=EmailSubject;
			pp_request.ReceiverType=receiverType;//Enum for ReceiverType is ReceiverInfoCodeType.EmailAddress

            // Execute the API operation and obtain the response.
			MassPayResponseType pp_response = (MassPayResponseType) caller.Call("MassPay", pp_request);
			return pp_response.Ack.ToString();

		}
	}
}
