/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * DoReauthorization SOAP example; last modified 08MAY23. 
 *
 * Reauthorize a previously authorized payment.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class Reauthorization
	{
	    public string ReauthorizationCode(string authorizationId, string value, CurrencyCodeType currencyId)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

			// Create the request object.
			DoReauthorizationRequestType pp_request = new DoReauthorizationRequestType
			                                              {
			                                                  Version = ConfigData.APIVersion,
			                                                  AuthorizationID = authorizationId,
			                                                  Amount = new BasicAmountType
			                                                               {
			                                                                   Value
			                                                                       =
			                                                                       value,
			                                                                   currencyID
			                                                                       =
			                                                                       currencyId
			                                                               }
			                                              };

	        // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        DoReauthorizationResponseType pp_response = (DoReauthorizationResponseType) caller.Call("DoReauthorization", pp_request);
			return pp_response.Ack.ToString();

		}
	}
}
