/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * SetCustomerBillingAgreement SOAP example; last modified 08MAY23. 
 *
 * Sets up a billing agreement for recurring payments.  
 */
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class SetCustomerBillingAgreement
	{
	    public string SetCustomerBillingAgreementCode(string returnURL, string cancelURL,  string Description)
		{
			CallerServices caller = new CallerServices();

			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

			// Create the request object.
			SetCustomerBillingAgreementRequestType pp_request=new SetCustomerBillingAgreementRequestType
			                                                      {
			                                                          SetCustomerBillingAgreementRequestDetails =
			                                                              new SetCustomerBillingAgreementRequestDetailsType(),
			                                                          Version = ConfigData.APIVersion
			                                                      };

	        // Add request-specific fields to the request.
			pp_request.SetCustomerBillingAgreementRequestDetails.CancelURL=cancelURL;
			pp_request.SetCustomerBillingAgreementRequestDetails.ReturnURL=returnURL;

			pp_request.SetCustomerBillingAgreementRequestDetails.BillingAgreementDetails=new BillingAgreementDetailsType
			                                                                                 {
			                                                                                     BillingAgreementDescription =
			                                                                                         Description,
			                                                                                     BillingType =
			                                                                                         BillingCodeType.
			                                                                                         RecurringPayments
			                                                                                 };

	        // Execute the API operation and obtain the response.
			SetCustomerBillingAgreementResponseType pp_response = (SetCustomerBillingAgreementResponseType) caller.Call("SetCustomerBillingAgreement", pp_request);
			return pp_response.Ack.ToString();
		}

	}
}
