/*
 * Copyright 2005, 2008 PayPal, Inc. All Rights Reserved.
 *
 * TransactionSearch SOAP example; last modified 08MAY23. 
 *
 * Search your account history for transactions that meet the criteria you specify.  
 */
using System;
using com.paypal.sdk.services;
using com.paypal.soap.api;
using com.paypal.sdk.profiles;

/**
 * PayPal .NET SDK sample code
 */
namespace SpiceLogic.PayPalProSOAP.Core
{
	public class TransactionSearch
	{
	    public string TransactionSearchnCode(DateTime startDate, DateTime endDate,string transactionId)
		{
			CallerServices caller = new CallerServices();
			IAPIProfile profile = ProfileFactory.createSignatureAPIProfile();
			/*
			 WARNING: Do not embed plaintext credentials in your application code.
			 Doing so is insecure and against best practices.
			 Your API credentials must be handled securely. Please consider
			 encrypting them for use in any production environment, and ensure
			 that only authorized individuals may view or modify them.
			 */

            // Set up your API credentials, PayPal end point, and API version.
            profile.APIUsername = ConfigData._apiUserName;
            profile.APIPassword = ConfigData._apiPassword;
            profile.APISignature = ConfigData._apiSignature;
            profile.Environment = ConfigData.PayPalEnvironment;
            caller.APIProfile = profile;

			// Create the request object.
			TransactionSearchRequestType concreteRequest = new TransactionSearchRequestType
			                                                   {
			                                                       Version = ConfigData.APIVersion,
			                                                       StartDate = startDate,
			                                                       EndDate = endDate.AddHours(23).AddMinutes(59).AddSeconds(59),
			                                                       EndDateSpecified = true,
			                                                       TransactionID = transactionId
			                                                   };

	        // Add request-specific fields to the request.

	        // Execute the API operation and obtain the response.
	        TransactionSearchResponseType pp_response = (TransactionSearchResponseType) caller.Call("TransactionSearch", concreteRequest);
			return pp_response.Ack.ToString();

		}
	}
}
